"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
require('rxjs/Rx');
var HttpInterceptor = (function (_super) {
    __extends(HttpInterceptor, _super);
    function HttpInterceptor(backend, defaultOptions) {
        _super.call(this, backend, defaultOptions);
        this.interceptors = [];
    }
    /**
     * Performs a request with `get` http method.
     * @param url
     * @param options
     * @returns {Observable<>}
     */
    HttpInterceptor.prototype.get = function (url, options) {
        var _this = this;
        return _super.prototype.get.call(this, url, this.requestOptions(options))
            .do(function (res) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.get(res);
            }
        }, function (error) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.get(error);
            }
        });
    };
    /**
     * Performs a request with `post` http method.
     * @param url
     * @param body
     * @param options
     * @returns {Observable<>}
     */
    HttpInterceptor.prototype.post = function (url, body, options) {
        var _this = this;
        return _super.prototype.post.call(this, url, body, this.requestOptions(options))
            .do(function (res) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.post(res);
            }
        }, function (error) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.post(error);
            }
        });
    };
    /**
     * Performs a request with `put` http method.
     * @param url
     * @param body
     * @param options
     * @returns {Observable<>}
     */
    HttpInterceptor.prototype.put = function (url, body, options) {
        var _this = this;
        return _super.prototype.put.call(this, url, body, this.requestOptions(options))
            .do(function (res) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.put(res);
            }
        }, function (error) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.put(error);
            }
        });
    };
    /**
     * Performs a request with `delete` http method.
     * @param url
     * @param options
     * @returns {Observable<>}
     */
    HttpInterceptor.prototype.delete = function (url, options) {
        var _this = this;
        return _super.prototype.delete.call(this, url, options)
            .do(function (res) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.delete(res);
            }
        }, function (error) {
            for (var _i = 0, _a = _this.interceptors; _i < _a.length; _i++) {
                var interceptor = _a[_i];
                interceptor.delete(error);
            }
        });
    };
    /**
     * Request options.
     * @param options
     * @returns {RequestOptionsArgs}
     */
    HttpInterceptor.prototype.requestOptions = function (options) {
        if (options == null) {
            options = new http_1.RequestOptions();
        }
        if (options.headers == null) {
            options.headers = new http_1.Headers();
        }
        return options;
    };
    HttpInterceptor.prototype.addInterceptor = function (interceptor) {
        this.interceptors.push(interceptor);
    };
    HttpInterceptor.prototype.removeInterceptor = function (interceptor) {
        for (var i = 0; i < this.interceptors.length; i++) {
            if (this.interceptors[i] == interceptor) {
                delete this.interceptors[i];
                return;
            }
        }
    };
    HttpInterceptor = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.ConnectionBackend, http_1.RequestOptions])
    ], HttpInterceptor);
    return HttpInterceptor;
}(http_1.Http));
exports.HttpInterceptor = HttpInterceptor;
//# sourceMappingURL=http-interceptor.js.map