"use strict";
var ionic_angular_1 = require("ionic-angular");
var Interceptor = (function () {
    function Interceptor(name) {
        var statusCodes = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            statusCodes[_i - 1] = arguments[_i];
        }
        this.statusCodes = [];
        this.ignoreURL = [];
        this.events = new ionic_angular_1.Events();
        this.name = "Interceptor:200";
        this.statusCodes = this.statusCodes.concat(statusCodes);
    }
    Interceptor.prototype.getName = function () {
        return this.name;
    };
    Interceptor.prototype.get = function (res, url) {
        if (this.statusCodes.indexOf(res.status) != -1) {
            if (this.ignoreURL.indexOf(url) == -1) {
                console.log("About to publish");
                this.events.publish("Interceptor:200");
            }
        }
    };
    Interceptor.prototype.post = function (res, url) {
        if (this.statusCodes.indexOf(res.status) != -1) {
            if (this.ignoreURL.indexOf(url) == -1) {
                this.events.publish("Interceptor:200");
            }
        }
    };
    Interceptor.prototype.put = function (res, url) {
        if (this.statusCodes.indexOf(res.status) != -1) {
            if (this.ignoreURL.indexOf(url) == -1) {
                this.events.publish("Interceptor:200");
            }
        }
    };
    Interceptor.prototype.delete = function (res, url) {
        if (this.statusCodes.indexOf(res.status) != -1) {
            if (this.ignoreURL.indexOf(url) == -1) {
                this.events.publish("Interceptor:200");
            }
        }
    };
    Interceptor.prototype.addIgnoreUrl = function () {
        var urls = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            urls[_i - 0] = arguments[_i];
        }
        this.ignoreURL = this.ignoreURL.concat(urls);
    };
    Interceptor.prototype.removeIgnoreUrls = function () {
        var urls = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            urls[_i - 0] = arguments[_i];
        }
        for (var _a = 0, urls_1 = urls; _a < urls_1.length; _a++) {
            var url = urls_1[_a];
            this.removeIgnoreUrl(url);
        }
    };
    Interceptor.prototype.removeIgnoreUrl = function (url) {
        var index = this.ignoreURL.indexOf(url);
        if (index != -1) {
            delete this.ignoreURL[index];
            this.removeIgnoreUrl(url);
        }
        else {
            return;
        }
    };
    Interceptor.prototype.getIgnoredUrls = function () {
        return this.ignoreURL;
    };
    Interceptor.prototype.addStatusCodes = function () {
        var statusCodes = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            statusCodes[_i - 0] = arguments[_i];
        }
        this.statusCodes = this.statusCodes.concat(statusCodes);
    };
    Interceptor.prototype.removeStatusCodes = function () {
        var statusCodes = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            statusCodes[_i - 0] = arguments[_i];
        }
        for (var _a = 0, statusCodes_1 = statusCodes; _a < statusCodes_1.length; _a++) {
            var statusCode = statusCodes_1[_a];
            this.removeStatusCode(statusCode);
        }
    };
    Interceptor.prototype.removeStatusCode = function (statusCode) {
        var index = this.statusCodes.indexOf(statusCode);
        if (index != -1) {
            delete this.statusCodes[index];
            this.removeStatusCode(statusCode);
        }
        else {
            return;
        }
    };
    Interceptor.prototype.getStatusCodes = function () {
        return this.statusCodes;
    };
    return Interceptor;
}());
exports.Interceptor = Interceptor;
//# sourceMappingURL=interceptor.js.map